{$N-}
Unit mousunit;
{
**************************************************************
*							     *
*	    Microsoft Mouse Interface Routines               *
*		    Unit version  1.0                        *
*							     *
*		    Copyright (C) 1988 by                    *
*		      Dr. Bernard Sttz                      *
*							     *
**************************************************************
}

			INTERFACE

uses crt, dos, graph;

type
  MouseMenuFlags = array [1 .. 20] of boolean;
  MaskType = array [0 .. 1, 0 .. 15] of word;
  MaskPointer = ^ MaskRecord;
  MaskRecord = record
		mask : masktype;
		x    : word;
		y    : word;
	      end;
var
  RightarrowCursor, DownArrowCursor, InvertedCursor : MaskRecord;
  jmysz                                             : boolean;
const
  LeftB : byte = 0;
  RightB : byte = 1;
  MiddleB : byte = 2;

  StandardCursor : MaskRecord
       = (mask:(($3fff,$1fff,$fff, $7ff, $3ff, $1ff, $ff,  $7f,
		 $3f,  $1f,  $1ff, $10ff,$30ff,$f87f,$f87f,$fc3f),
		($0,   $4000,$6000,$7000,$7800,$7c00,$7e00,$7f00,
		 $7f80,$7fc0,$7c00,$4600,$600, $300, $300, $180));
		x:0; y:0);
var
    regs : registers;

procedure ResetMouse;
procedure ShowMouse;
procedure HideMouse;
procedure MousePos (var x, y : word); { podaje pozycje myszy }
function LeftButton : boolean;
function RightButton : boolean;
function MiddleButton : boolean;
procedure PutMouse (x, y : word);  { kladzie mysz w wspol. x,y }
function ButtonPressInfo (button : byte;
			  var presscount, x ,y : word): boolean; { x,y - podaje
                          pozycje, a count ilosc klikniec buttona - mile
                          widziany delay }
function ButtonReleaseInfo (button : word;
			    var presscount, x ,y : word): boolean; { co wyzej ,
                            lecz sprawdza nie klikniety buton }
procedure SetHorizontalRange (min, max : word); { ogranicza w x }
procedure SetVerticalRange (min, max : word);   { ogranicza w y }
function  MouseInBox (x1, y1, x2, y2 : word): boolean; { gdy mysz w klatce to TRUE }
procedure SetGraphicsCursor (var maskp : maskrecord); { ustawianie typu kursora }
procedure SetTextCursor (sel, start, stop : word);
procedure MouseRatio (x, y : word);  { czulosc w x,y - im mniejsza wielkos
                                        tym wieksza czulosc }
procedure MotionCounters (var x, y : integer); { podaje przyrosty od ostatniego
                                                 polozenia }
procedure LightPenEmulation (f : boolean); { hgw }
procedure ConditionalOff (ux, uy, lx, ly : word); { gdy wejdziesz w prostokat
                                                    o w/w wspol. to znikasz }
procedure DoubleSpeedThreshold (mickey : word); { ustawia predkosc w x,y - im mniej
                                                  tym szybciej biega }



			IMPLEMENTATION
label koniec;
var
  {CrtMode : byte absolute $40:$49;
}
  MouseHandler : pointer;
  ExitSave : pointer;
  Int1BSave : pointer;
  OldCursor : pointer;

const
  m1 : word = 0;
  m2 : word = 0;
  m3 : word = 0;
  m4 : word = 0;
  m5 : word = 0;
  m6 : word = 0;

  MaxX : integer = 639;
  MaxY : integer = 349;
  SegPointer : word = $ffff;
  GDriver : integer = Detect;
  GMode : integer = 0;
  Aboflag : boolean = false;
  Hercules : boolean = false;

{ *****							***** }
function BitSet (testbyte : byte; bitnumber : byte): boolean;
  begin
    testbyte := testbyte and (1 shl bitnumber);
    bitset := (testbyte > 0);
  end;

{ *****				***** }
procedure CheckPos (var x, y : word);
  begin
    if y > MaxY
      then
	y := MaxY;
    if x > MaxX
      then
	x := MaxX;
  end;

{ *****	  ***** }
procedure Mouse;
var a:integer;  
  begin
    with regs do
      begin
	ax := m1;
	bx := m2;
	cx := m3;
	dx := m4;
	si := m5;
	di := m6;
	es := SegPointer;
{	for a:=1 to 15000 do Intr(a,regs);}
	Intr (51, regs);
	m1 := ax;
	m2 := bx;
	m3 := cx;
	m4 := dx;
      end;
  end;

{ ******     ***** }
procedure ShowMouse;
  begin
    m1 := 1;
    Mouse;
  end;

{ ******      ***** }
procedure HideMouse;
  begin
    m1 := 2;
    Mouse;
  end;

{ ******			***** }
procedure MousePos (var x, y : word);
  begin
    m1 := 3;
    Mouse;
    x := m3;
    y := m4;
    if AboFlag
      then
	begin
	  CloseGraph;
	  NoSound;
	  writeln ('Break');
	  halt (1);
	end;
  end;

{ *****			****** }
function LeftButton : boolean;
  begin
    m1 := 3;
    Mouse;
    if BitSet (M2, LeftB )
      then
	LeftButton := true
      else
	LeftButton := false;
  end;

{ *****			****** }
function RightButton : boolean;
  begin
    m1 := 3;
    Mouse;
    if BitSet (M2, RightB )
      then
	RightButton := true
      else
	RightButton := false;
  end;

{ *****			****** }
function MiddleButton : boolean;
  begin
    m1 := 3;
    Mouse;
    if BitSet (M2, MiddleB )
      then
	MiddleButton := true
      else
	MiddleButton := false;
  end;

{ *****			***** }
procedure PutMouse (x, y : word);
  begin
    CheckPos (x, y);
    m1 := 4;
    m3 := x;
    m4 := y;
    Mouse;
  end;

{ *****				***** }
function ButtonPressInfo (button : byte;
			   var presscount, x, y : word): boolean;
  begin
    m1 := 5;
    m2 := button;
    Mouse;
    ButtonPressInfo := BitSet (m1, button);
    PressCount := m2;
    x := m3;
    y := m4;
  end;

{ *****				***** }
function ButtonReleaseInfo (button : word;
			   var presscount, x, y : word): boolean;
  begin
    m1 := 6;
    m2 := button;
    Mouse;
    ButtonReleaseInfo := not BitSet (m1, button);
    PressCount := m2;
    x := m3;
    y := m4;
  end;

{ *****					***** }
procedure SetHorizontalRange (min, max : word);
  var
    dummy : word;
  begin
    CheckPos (min, dummy);
    CheckPos (max, dummy);
    m1 := 7;
    m3 := min;
    m4 := max;
    Mouse;
  end;

{ *****					***** }
procedure SetVerticalRange (min, max : word);
  var
    dummy : word;
  begin
    CheckPos (dummy, min);
    CheckPos (dummy, max);
    m1 := 8;
    m3 := min;
    m4 := max;
    Mouse;
  end;


function MouseInBox (x1, y1, x2, y2 : word): boolean;
  var
    x, y : word;
  begin
    if x2 < x1
      then
	begin
	  x := x1;
	  x1 := x2;
	  x2 := x;
	end;
    if y2 < y1
      then
	begin
	  y := y1;
	  y1 := y2;
	  y2 := y;
	end;
    MousePos (x, y);
    MouseInBox := (((x>=x1) and (x<=x2)) and ((y>=y1) and (y<=y2)));
  end;

{ *****						***** }
procedure SetGraphicsCursor (var maskp : maskrecord);
  begin
    if oldcursor <> @maskp
      then
	begin
	  oldcursor := @maskp;
	  with maskp do
	    begin
	      m1 := 9;
	      m2 := x;
	      m3 := y;
	      m4 := ofs (mask);
	      segpointer := seg (mask);
	    end;
	end;
  end;

{ *****					***** }
procedure SetTextCursor (sel, start, stop : word);
  begin
    m1 := 10;
    m2 := sel;
    m3 := start;
    m4 := stop;
    Mouse;
  end;

{ *****			   ***** }
procedure MouseRatio (x, y :  word);
  begin
    m1 := 15;
    m3 := x;
    m4 := y;
    Mouse;
  end;

{ *****					***** }
procedure MotionCounters (var x, y : integer);
  var
    x1, y1 : longint;
  begin
    m1 := 11;
    Mouse;
    if m3 > $fff
      then
	x1 := m3 - 65536
      else
	x1 := m3;
    if m4 > $fff
      then
	y1 := m4 - 65536
      else
	y1 := m4;
    x := x1;
    y := y1;
  end;

{ *****				***** }
procedure LightPenEmulation (f : boolean);
  begin
    if f
      then
       m1 := 13
      else
	m1 := 14;
    Mouse;
  end;

{ *****					***** }
Procedure ConditionalOff (ux, uy, lx, ly : word);
  begin
    m1 := 16;
    if ux < lx
      then
	begin
	  m3 := ux;
	  m5 := lx;
	end
      else
	begin
	  m3 := lx;
	  m5 := ux;
	end;
    if uy < ly
      then
	begin
	  m4 := uy;
	  m6 := ly;
	end
      else
	begin
	  m4 := ly;
	  m6 := uy;
	end;
    Mouse;
  end;

{ *****					***** }
procedure DoubleSpeedThreshold (mickey : word);
  begin
    m1 := 19;
    m4 := mickey;
    Mouse;
  end;

{ *****		***** }
procedure MouseCallExit;
  begin
    {inline ($5D/$58/$58/$89/$EC/$5D/$07/$1F/
	    $5F/$5E/$5A/$59/$5B/$58/$CB);
}
    { pop bp ; pop ax ; pop ax ; mov sp,bp ; pop es ; pop ds ;
      pop di ; pop si ; pop dx ; pop cx ; pop bx  ; pop ax ;
      ret far }
  end;


{ *****								***** }
procedure MouseInterrupt (Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP : word);
	interrupt;
  begin
    {UserHandlerCall (AX, BX, CX, DX);
}
    MouseCallExit;
  end;

{ *****					   ***** }

procedure ResetMouse;
  var
    size : word;
    save : boolean;
  begin
    DetectGraph (GDriver, GMode);
    {if GDriver = 7
      then
	begin
	  CrtMode := 6;
	  Hercules := true;
	end;}
    m1 := 0;
    Mouse;
    MaxX := GetMaxX-1;
    MaxY := GetMaxY-1;
    SetHorizontalRange (0, MaxX);
    SetVerticalRange (0, MaxY);
  end;



begin
  jmysz:=true;
  m1 := 0;
  Mouse;
  if not (m1 = 65535) then
  begin jmysz:=false;
        goto koniec;
  end;

  MaxX := 79;
  MaxY := 24;
  Clrscr;

  ExitSave := ExitProc;
  {ExitProc := @MouseExit;
}
  GetIntVec ($1B, Int1BSave);
  {setIntVec ($1B, @Int1B);
}
koniec:
end.
